## sambamba 0.6.6

=== Makefile ===
D_COMPILER=dmd
D_FLAGS=--compiler=dmd -IBioD -IundeaD/src -g -d#-O -release -inline # -version=serial
LDMD=ldmd2

STATIC_LIB_PATH=-Lhtslib -Llz4/lib
STATIC_LIB_SUBCMD=$(STATIC_LIB_PATH) -Wl,-Bstatic -lhts -llz4 -Wl,-Bdynamic
RDMD_FLAGS=--force --build-only --compiler=$(D_COMPILER) $(D_FLAGS)

PLATFORM := $(shell uname -s)

ifeq "$(PLATFORM)" "Darwin"

LINK_CMD=gcc -dead_strip -lphobos2-ldc -ldruntime-ldc -lm -lpthread htslib/libhts.a lz4/lib/liblz4.a build/sambamba.o -o build/sambamba
DMD_STATIC_LIBS=htslib/libhts.a lz4/lib/liblz4.a

define split-debug
dsymutil build/sambamba -o build/sambamba.dSYM
strip -S build/sambamba
endef

else

LINK_CMD=gcc -Wl,--gc-sections -o build/sambamba build/sambamba.o $(STATIC_LIB_SUBCMD) -l:libphobos2-ldc.a -l:libdruntime-ldc.a  -lrt -lpthread -lm
DMD_STATIC_LIBS=-L-Lhtslib -L-l:libhts.a -L-l:libphobos2.a -L-Llz4/lib -L-l:liblz4.a

define split-debug
objcopy --only-keep-debug build/sambamba sambamba.debug
objcopy --strip-debug build/sambamba
objcopy --add-gnu-debuglink=sambamba.debug build/sambamba
mv sambamba.debug build/
endef

endif

PREREQS := ldc-version-info htslib-static lz4-static

# DMD only - this goal is used because of fast compilation speed, during development
all: $(PREREQS)
	mkdir -p build/
	rdmd --force --build-only $(D_FLAGS) $(DMD_STATIC_LIBS) -ofbuild/sambamba main.d

# This is the main Makefile goal, used for building releases (best performance)
sambamba-ldmd2-64: $(PREREQS)
	mkdir -p build/
	$(LDMD) @sambamba-ldmd-release.rsp
	$(LINK_CMD)
	$(split-debug)

# For debugging; GDB & Valgrind are more friendly to executables created using LDC/GDC than DMD
sambamba-ldmd2-debug: $(PREREQS)
	mkdir -p build/
	$(LDMD) @sambamba-ldmd-debug.rsp
	$(LINK_CMD)

ldc-version-info:
	./gen_ldc_version_info.py $(shell which $(LDMD)) > utils/ldc_version_info_.d

htslib-static:
	cd htslib && $(MAKE)

lz4-static: lz4/lib/liblz4.a

lz4/lib/liblz4.a: lz4/lib/lz4.c lz4/lib/lz4hc.c lz4/lib/lz4frame.c lz4/lib/xxhash.c
	cd lz4/lib && $(CC) -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o

# all below link to libhts dynamically for simplicity

sambamba-flagstat:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-flagstat sambamba/flagstat.d

sambamba-merge:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-merge sambamba/merge.d

sambamba-index:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-index sambamba/index.d

sambamba-sort:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-sort sambamba/sort.d

sambamba-view:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-view sambamba/view.d

sambamba-slice:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-slice sambamba/slice.d

sambamba-markdup:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-markdup sambamba/markdup.d

sambamba-depth:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-depth sambamba/depth.d

sambamba-pileup:
	mkdir -p build/
	rdmd $(RDMD_FLAGS) -L-lhts -version=standalone -ofbuild/sambamba-pileup sambamba/pileup.d

.PHONY: clean ldc-version-info

clean:
	rm -rf build/ ; $(MAKE) -C htslib clean ; $(MAKE) -C lz4 clean

=== debian/changelog ===
sambamba (0.6.6-1) unstable; urgency=medium

  * Initial release (Closes: #871497)

 -- Andreas Tille <tille@debian.org>  Tue, 08 Aug 2017 17:20:06 +0200

=== debian/control ===
Source: sambamba
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 10.4),
               ldc,
               libbiod-dev (>= 0.1.0-4),
               libhts-dev,
               liblz4-dev,
               libundead-dev (>= 1.0.7-1),
               meson (>= 0.40),
               pkg-config,
               python,
               zlib1g-dev
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/sambamba.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/sambamba.git
Homepage: https://github.com/lomereiter/sambamba

Package: sambamba
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: tools for working with SAM/BAM data
 Sambamba provides tools for
  * Powerful filtering with sambamba view --filter
  * Picard-like SAM header merging in the merge tool
  * Optional for operations on whole BAMs
  * Fast copying of a region to a new file with the slice tool
  * Duplicate marking/removal, using the Picard criteria

=== debian/rules ===
#!/usr/bin/make -f
# DH_VERBOSE := 1

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DFLAGS=-O3 -g -release

# we can not build with NEON on armhf, the Debian builders
# don't support it.
ifeq ($(DEB_HOST_ARCH),armhf)
	DFLAGS += -mattr=-neon
endif

%:
	dh $@ --buildsystem=meson

override_missing:
	dh_missing --list-missing

## sambamba 0.6.7

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 else
 
-LINK_CMD=gcc -Wl,--gc-sections -o build/sambamba build/sambamba.o $(STATIC_LIB_SUBCMD) -l:libphobos2-ldc.a -l:libdruntime-ldc.a  -lrt -lpthread -lm
+LINK_CMD=gcc -Wl,--gc-sections -o build/sambamba build/sambamba.o $(STATIC_LIB_SUBCMD) -lphobos2-ldc -ldruntime-ldc  -lrt -lpthread -lm -ldl
 DMD_STATIC_LIBS=-L-Lhtslib -L-l:libhts.a -L-l:libphobos2.a -L-Llz4/lib -L-l:liblz4.a
 
 define split-debug

=== debian/changelog ===
sambamba (0.6.7-2) unstable; urgency=medium

  * Team upload.
  * Disable assert on i386, this is a new assert, but the current
    package is already broken on i386.
    Upstream is working on a proper fix, in the meantime we can let
    the package migrate without removing i386 or making things worse
    for this architecture. Closes: #893664
    See: https://github.com/biod/sambamba/issues/344 (and issue 300)

  [ Steffen Möller ]
  * Update upstream metadata file

  [ Matthias Klumpp ]
  * Fail on missing files
  * Do not force disable of neon on armhf in rules file, already
    handled by dh-dlang

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Apr 2018 12:10:12 +0200

sambamba (0.6.7-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata:
    - yamllint cleanliness
    - added references to registries

  [ Andreas Tille ]
  * New upstream version
  * Use dh-dlang
  * Standards-Version: 4.1.3
  * debhelper 11
  * enable hardening options
  * move bash_completion scripts to new location

 -- Andreas Tille <tille@debian.org>  Tue, 20 Mar 2018 10:53:49 +0100

=== debian/control ===
Source: sambamba
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               dh-dlang,
               libbiod-dev (>= 0.1.0-5),
               libhts-dev,
               liblz4-dev,
               libundead-dev (>= 1.0.9-2),
               meson (>= 0.40),
               pkg-config,
               python,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/sambamba.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/sambamba.git
Homepage: https://github.com/lomereiter/sambamba

Package: sambamba
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: tools for working with SAM/BAM data
 Sambamba positions itself as a performant alternative
 to samtools and provides tools for
  * Powerful filtering with sambamba view --filter
  * Picard-like SAM header merging in the merge tool
  * Optional for operations on whole BAMs
  * Fast copying of a region to a new file with the slice tool
  * Duplicate marking/removal, using the Picard criteria

=== debian/rules ===
#!/usr/bin/make -f
# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dh-dlang/dlang-flags.mk

%:
	dh $@ --buildsystem=meson

override_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4

https://github.com/lomereiter/sambamba/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## sambamba 0.7.1

=== Makefile ===
# This is a minimalistic make file to build sambamba with ldc2 as per instructions on
# https://github.com/biod/sambamba#compiling-sambamba
#
# Targets (64-bit):
#
#   Linux
#   OSX
#
# Typical usage:
#
#   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib debug|profile|release|static
#
# Static release with optimization (for releases):
#
#   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib pgo-static
#
# Debug version
#
#   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib debug
#

D_COMPILER=ldc2

UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
  SYS = OSX
else
  SYS = LINUX
endif

DFLAGS      = -wi -I. -IBioD -g -J.

DLIBS       = $(LIBRARY_PATH)/libphobos2-ldc.a $(LIBRARY_PATH)/libdruntime-ldc.a
DLIBS_DEBUG = $(LIBRARY_PATH)/libphobos2-ldc-debug.a $(LIBRARY_PATH)/libdruntime-ldc-debug.a
LIBS        = htslib/libhts.a lz4/lib/liblz4.a -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz
LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) htslib/libhts.a $(LIBRARY_PATH)/liblz4.a -L-lz
SRC         = utils/ldc_version_info_.d utils/lz4.d utils/strip_bcf_header.d $(sort $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d)) utils/version_.d $(sort $(wildcard thirdparty/*.d cram/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d))
OBJ         = $(SRC:.d=.o)
OUT         = bin/sambamba-$(shell cat VERSION)

STATIC_LIB_PATH=-Lhtslib -Llz4

.PHONY: all debug release static clean test

all: release

debug:                             DFLAGS += -O0 -d-debug -link-debuglib

profile:                           DFLAGS += -fprofile-instr-generate=profile.raw

coverage:                          DFLAGS += -cov

release static pgo-static:         DFLAGS += -O3 -release -enable-inlining -boundscheck=off -L-lz

static:                            DFLAGS += -static -L-Bstatic

pgo-static:                        DFLAGS += -fprofile-instr-use=profile.data

lz4-static: lz4/lib/liblz4.a

lz4/lib/liblz4.a: lz4/lib/lz4.c lz4/lib/lz4hc.c lz4/lib/lz4frame.c lz4/lib/xxhash.c
	cd lz4/lib && gcc -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o

htslib-static:
	cd htslib && $(MAKE) -j8

utils/ldc_version_info_.d:
	python3 ./gen_ldc_version_info.py $(shell which ldmd2) > utils/ldc_version_info_.d
	cat utils/ldc_version_info_.d

ldc_version_info: utils/ldc_version_info_.d

build-setup: ldc_version_info lz4-static htslib-static
	mkdir -p bin/

default debug release static: $(OUT)

coverage: debug

profile: debug
	$(OUT) sort /gnu/data/in_raw.bam -p > /dev/null
	ldc-profdata merge -output=profile.data profile.raw
	rm $(OUT) ./bin/sambamba.o # trigger rebuild

default: all

# ---- Compile step
%.o: %.d
	$(D_COMPILER) $(DFLAGS) -c $< -od=$(dir $@)

singleobj: build-setup
	$(info compile single object...)
	$(D_COMPILER) -singleobj $(DFLAGS) -c -of=$(OUT).o $(SRC)

# ---- Link step
$(OUT): singleobj
	$(info linking...)
	$(D_COMPILER) $(DFLAGS) -of=$(OUT) $(OUT).o $(LINK_OBJ) $(LIBS)

test: $(OUT)
	$(OUT) --version
	./run_tests.sh $(OUT)

check: test

debug-strip:
	objcopy --only-keep-debug bin/sambamba sambamba.debug
	objcopy --strip-debug bin/sambamba
	objcopy --add-gnu-debuglink=sambamba.debug bin/sambamba
	mv sambamba.debug bin/

pgo-static: static debug-strip

install:
	install -m 0755 bin/sambamba $(prefix)/bin

clean: clean-d
	cd htslib ; $(MAKE) clean
	rm lz4/lib/*.[oa]
	rm -f profile.data
	rm -f profile.raw

clean-d:
	rm -rf bin/*
	rm -vf utils/ldc_version_info_.d
	rm -f $(OBJ) $(OUT) trace.{def,log}

=== debian/changelog ===
sambamba (0.7.1-4) unstable; urgency=medium

  * d/control: 
    - versioned dependency on htslib-dev to request non-stripped libhts.a
    - Standards-Version: 4.5.0
    - debhelper-compat 13
    - Rules-Requires-Root: no
    - Completed dependencies for cowbuilder
  * d/rules: better clean

 -- Steffen Moeller <moeller@debian.org>  Sun, 05 Jul 2020 01:53:01 +0200

sambamba (0.7.1-3) unstable; urgency=medium

  * Fixed build failure (Closes: # 948919)
    with
    - dependency on newer htslib package that is not stripped
    - and exports the cram_to_bam function
    - avoided use of inline htslib function by sambamba
    Upstream informed on https://github.com/samtools/htslib/issues/1098

 -- Steffen Moeller <moeller@debian.org>  Sat, 04 Jul 2020 19:18:06 +0200

sambamba (0.7.1-2) UNRELEASED; urgency=medium

  * Use 2to3 to port from Python2 to Python3
    Closes: #938431
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Tue, 17 Dec 2019 21:03:13 +0100

sambamba (0.7.1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream release
    Closes: #907489
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Add build time test
  * Allow pre-releases in watch file
  * Versioned Build-Depends: libbiod (>= 0.2.1)

  [ Steffen Möller ]
  * Update metadata with ref to conda

  [ Matthias Klumpp ]
  * New upstream version: 0.7.1
  * Run tests and build with strong optimizations
  * add-meson-build.patch: Update Meson build definition
    - Closes: #907489
    - We link against BioD stantically now
    - Tests are integrated into Meson
    - Allow switching on stronger optimizations used by the
      upstream Makefile
  * Depend on latest libbiod (>= 0.2.3)
  * Don't depend on libundead
  * Bump dh compat level to 12
  * Bump standards version (No changes needed)
  * Remove test artifacts in clean target

 -- Matthias Klumpp <mak@debian.org>  Sun, 15 Dec 2019 12:52:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,20 +3,27 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                dh-dlang,
-               libbiod-dev (>= 0.1.0-5),
-               libhts-dev,
+               libbiod-dev (>= 0.2.3),
+               libhts-dev (>= 1.10.2-4),
+               meson (>= 0.48),
+               pkg-config,
+               python3,
+               shunit2 <!nocheck>,
+               zlib1g-dev,
+# used by libhts and explicitly referenced in build instruction
                liblz4-dev,
-               libundead-dev (>= 1.0.9-2),
-               meson (>= 0.40),
-               pkg-config,
-               python,
-               zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/sambamba.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/sambamba.git
+               libcurl-dev,
+               libssl-dev,
+               libbz2-dev,
+               libdeflate-dev,
+               liblzma-dev
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/sambamba
+Vcs-Git: https://salsa.debian.org/med-team/sambamba.git
 Homepage: https://github.com/lomereiter/sambamba
+Rules-Requires-Root: no
 
 Package: sambamba
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# DH_VERBOSE := 1

include /usr/share/dh-dlang/dlang-flags.mk

%:
	mkdir -p obj-$(shell dpkg-architecture -qDEB_TARGET_GNU_TYPE)
	dh $@ --buildsystem=meson

override_dh_auto_configure:
	dh_auto_configure -- -Doptimize_strong=true -Dcpp_link_args="-wi -L=-z -L=relro -L=/usr/lib/x86_64-linux-gnu/libbiod.a /usr/lib/x86_64-linux-gnu/libhts.a -L=-lz -L=-lcrypto -L=-lcurl -L=-llzma -L=-lbz2 -L=-ldeflate -L=-llz4"

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CURDIR)/output/
	rm -f test.log

override_dh_auto_test:
	# tests seem broken

## sambamba 0.8.0

=== Makefile ===
--- 
+++ 
@@ -32,13 +32,13 @@
 
 DLIBS       = $(LIBRARY_PATH)/libphobos2-ldc.a $(LIBRARY_PATH)/libdruntime-ldc.a
 DLIBS_DEBUG = $(LIBRARY_PATH)/libphobos2-ldc-debug.a $(LIBRARY_PATH)/libdruntime-ldc-debug.a
-LIBS        = htslib/libhts.a lz4/lib/liblz4.a -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz
-LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) htslib/libhts.a $(LIBRARY_PATH)/liblz4.a -L-lz
-SRC         = utils/ldc_version_info_.d utils/lz4.d utils/strip_bcf_header.d $(sort $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d)) utils/version_.d $(sort $(wildcard thirdparty/*.d cram/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d))
+LIBS        = lz4/lib/liblz4.a -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz
+LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) $(LIBRARY_PATH)/liblz4.a -L-lz
+SRC         = utils/ldc_version_info_.d utils/lz4.d utils/strip_bcf_header.d $(sort $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d)) utils/version_.d $(sort $(wildcard thirdparty/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d))
 OBJ         = $(SRC:.d=.o)
 OUT         = bin/sambamba-$(shell cat VERSION)
 
-STATIC_LIB_PATH=-Lhtslib -Llz4
+STATIC_LIB_PATH=-Llz4
 
 .PHONY: all debug release static clean test
 
@@ -61,16 +61,13 @@
 lz4/lib/liblz4.a: lz4/lib/lz4.c lz4/lib/lz4hc.c lz4/lib/lz4frame.c lz4/lib/xxhash.c
 	cd lz4/lib && gcc -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o
 
-htslib-static:
-	cd htslib && $(MAKE) -j8
-
 utils/ldc_version_info_.d:
 	python3 ./gen_ldc_version_info.py $(shell which ldmd2) > utils/ldc_version_info_.d
 	cat utils/ldc_version_info_.d
 
 ldc_version_info: utils/ldc_version_info_.d
 
-build-setup: ldc_version_info lz4-static htslib-static
+build-setup: ldc_version_info lz4-static
 	mkdir -p bin/
 
 default debug release static: $(OUT)
@@ -115,7 +112,6 @@
 	install -m 0755 bin/sambamba $(prefix)/bin
 
 clean: clean-d
-	cd htslib ; $(MAKE) clean
 	rm lz4/lib/*.[oa]
 	rm -f profile.data
 	rm -f profile.raw

=== debian/changelog ===
sambamba (0.8.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 04 Dec 2020 21:21:52 +0100

sambamba (0.7.1-5) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * DEP3
  * Lintian-override for static linking

  [ Étienne Mollier ]
  * Define zlib dependency in meson.build.  (Closes: #966914)
  * Default to libcurl4-gnutls-dev as libcurl-dev dependency.  (Fixes
    lintian virtual-package-depends-without-real-package-depends)

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Wed, 11 Nov 2020 09:27:56 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-dlang,
-               libbiod-dev (>= 0.2.3),
+               libbiod-dev,
                libhts-dev (>= 1.10.2-4),
                meson (>= 0.48),
                pkg-config,
@@ -14,12 +14,12 @@
                zlib1g-dev,
 # used by libhts and explicitly referenced in build instruction
                liblz4-dev,
-               libcurl-dev,
+               libcurl4-gnutls-dev | libcurl-dev,
                libssl-dev,
                libbz2-dev,
                libdeflate-dev,
                liblzma-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/sambamba
 Vcs-Git: https://salsa.debian.org/med-team/sambamba.git
 Homepage: https://github.com/lomereiter/sambamba

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,6 @@
 	rm -f test.log
 
 override_dh_auto_test:
-	# tests seem broken
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	echo "FIXME: Build time tests needs fixing"
+endif

=== debian/watch ===
version=4

opts="uversionmangle=s/-/~/" \
  https://github.com/lomereiter/sambamba/releases .*/archive/v(\d[\d.pre-]+)@ARCHIVE_EXT@

## sambamba 0.8.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -52,14 +52,14 @@
 
 release static pgo-static:         DFLAGS += -O3 -release -enable-inlining -boundscheck=off -L-lz
 
-static:                            DFLAGS += -static -L-Bstatic
+static:                            DFLAGS += -static -L-Bstatic -link-defaultlib-shared=false
 
 pgo-static:                        DFLAGS += -fprofile-instr-use=profile.data
 
 lz4-static: lz4/lib/liblz4.a
 
 lz4/lib/liblz4.a: lz4/lib/lz4.c lz4/lib/lz4hc.c lz4/lib/lz4frame.c lz4/lib/xxhash.c
-	cd lz4/lib && gcc -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o
+	cd lz4/lib && $(CC) -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o
 
 utils/ldc_version_info_.d:
 	python3 ./gen_ldc_version_info.py $(shell which ldmd2) > utils/ldc_version_info_.d

=== debian/changelog ===
sambamba (0.8.1+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild against libphobos2-ldc-shared98

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 10 Dec 2021 17:15:21 +0000

sambamba (0.8.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Refresh Patches
    + Replace DEB_TARGET_GNU_TYPE with DEB_HOST_MULTIARCH to find library
    + Fix fuzz in other patches

 -- Nilesh Patra <nilesh@debian.org>  Wed, 25 Aug 2021 20:10:28 +0530

sambamba (0.8.0+dfsg-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Möller ]
  * Update metadata - added ref to guix, fixed indent

  [ Nilesh Patra ]
  * Add autopkgtests
  * d/watch: Fix watch regex
  * Repack to remove embedded shunit2
  * d/lintian-overrides: Fix override
  * Add d/gbp.conf
  * d/salsa-ci.yml: Do not run build on i386, disable reprotest
  * d/copyright: Fix all copyrights (Closes: #991371)

 -- Nilesh Patra <nilesh@debian.org>  Tue, 17 Aug 2021 21:11:39 +0530

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: sambamba
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
@@ -19,7 +20,7 @@
                libbz2-dev,
                libdeflate-dev,
                liblzma-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/sambamba
 Vcs-Git: https://salsa.debian.org/med-team/sambamba.git
 Homepage: https://github.com/lomereiter/sambamba

=== debian/watch ===
version=4

opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
  https://github.com/lomereiter/sambamba/releases .*/archive/.*/v(\d[\d.pre-]+)@ARCHIVE_EXT@

## sambamba 0.8.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,9 @@
 # This is a minimalistic make file to build sambamba with ldc2 as per instructions on
 # https://github.com/biod/sambamba#compiling-sambamba
+#
+# Note that this make file generates the most optimal binary for
+# sambamba (as a single run of ldc2 with aggressive inlining). For
+# development you may want to opt for meson+ninja or Makefile.guix instead.
 #
 # Targets (64-bit):
 #
@@ -12,14 +16,15 @@
 #
 # Static release with optimization (for releases):
 #
-#   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib pgo-static
+#   env CC=gcc make static
 #
 # Debug version
 #
-#   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib debug
+#   make debug
 #
 
 D_COMPILER=ldc2
+CC=gcc
 
 UNAME_S := $(shell uname -s)
 ifeq ($(UNAME_S),Darwin)
@@ -30,15 +35,14 @@
 
 DFLAGS      = -wi -I. -IBioD -g -J.
 
-DLIBS       = $(LIBRARY_PATH)/libphobos2-ldc.a $(LIBRARY_PATH)/libdruntime-ldc.a
+# DLIBS       = $(LIBRARY_PATH)/libphobos2-ldc.a $(LIBRARY_PATH)/libdruntime-ldc.a
 DLIBS_DEBUG = $(LIBRARY_PATH)/libphobos2-ldc-debug.a $(LIBRARY_PATH)/libdruntime-ldc-debug.a
-LIBS        = lz4/lib/liblz4.a -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz
-LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) $(LIBRARY_PATH)/liblz4.a -L-lz
+LIBS        = -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz -L-llz4
+# LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) -L-llz4 -L-lz
+LIBS_STATIC = $(DLIBS) -L-lz -L-llz4 -L-lphobos2-ldc -L-ldruntime-ldc
 SRC         = utils/ldc_version_info_.d utils/lz4.d utils/strip_bcf_header.d $(sort $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d)) utils/version_.d $(sort $(wildcard thirdparty/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d))
 OBJ         = $(SRC:.d=.o)
 OUT         = bin/sambamba-$(shell cat VERSION)
-
-STATIC_LIB_PATH=-Llz4
 
 .PHONY: all debug release static clean test
 
@@ -52,14 +56,9 @@
 
 release static pgo-static:         DFLAGS += -O3 -release -enable-inlining -boundscheck=off -L-lz
 
-static:                            DFLAGS += -static -L-Bstatic -link-defaultlib-shared=false
+static:                            DFLAGS += -static -L-Bstatic -link-defaultlib-shared=false $(LIBS_STATIC)
 
 pgo-static:                        DFLAGS += -fprofile-instr-use=profile.data
-
-lz4-static: lz4/lib/liblz4.a
-
-lz4/lib/liblz4.a: lz4/lib/lz4.c lz4/lib/lz4hc.c lz4/lib/lz4frame.c lz4/lib/xxhash.c
-	cd lz4/lib && $(CC) -O3 -c lz4.c lz4hc.c lz4frame.c xxhash.c && $(AR) rcs liblz4.a lz4.o lz4hc.o lz4frame.o xxhash.o
 
 utils/ldc_version_info_.d:
 	python3 ./gen_ldc_version_info.py $(shell which ldmd2) > utils/ldc_version_info_.d
@@ -67,7 +66,7 @@
 
 ldc_version_info: utils/ldc_version_info_.d
 
-build-setup: ldc_version_info lz4-static
+build-setup: ldc_version_info
 	mkdir -p bin/
 
 default debug release static: $(OUT)
@@ -109,10 +108,9 @@
 pgo-static: static debug-strip
 
 install:
-	install -m 0755 bin/sambamba $(prefix)/bin
+	install -m 0755 $(OUT) $(prefix)/bin
 
 clean: clean-d
-	rm lz4/lib/*.[oa]
 	rm -f profile.data
 	rm -f profile.raw

=== meson_options.txt ===
option('optimize_strong', type : 'boolean', value: false)

=== BioD/bio/etc/ragel/Makefile ===
all: fastrecordparser recordparser regionparser

.PHONY : fastrecordparser

.PHONY : recordparser

.PHONY : regionparser

fastrecordparser:
	ragel sam_alignment.rl -D -G2
	./workarounds/fix_switch_case_fallthrough.sh sam_alignment.d
	echo 'module bio.sam.utils.fastrecordparser;' | cat - sam_alignment.d > .sam_alignment.d.tmp
	rm sam_alignment.d
	mv .sam_alignment.d.tmp fastrecordparser.d
	mv fastrecordparser.d ../bio/sam/utils/fastrecordparser.d

recordparser:
	ragel sam_alignment.rl -D
	./workarounds/fix_static_const.sh sam_alignment.d
	echo 'module bio.sam.utils.recordparser;' | cat - sam_alignment.d > .sam_alignment.d.tmp
	rm sam_alignment.d
	mv .sam_alignment.d.tmp recordparser.d
	mv recordparser.d ../bio/sam/utils/recordparser.d

regionparser:
	ragel region.rl -D
	./workarounds/fix_static_const.sh region.d
	mv region.d ../bio/core/region.d

clean:
	rm -f *parser.d region.d

=== debian/changelog ===
sambamba (0.8.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Build specifically needs ldc2 (from ldc package), thus adding ldc as
    explicit build dependency.

 -- Andrius Merkys <merkys@debian.org>  Sat, 19 Feb 2022 02:36:22 -0500

sambamba (0.8.2+dfsg-1) unstable; urgency=medium

  * Drop debian/gbp.conf
  * d/rules: Do not link against libbiod
  * New upstream version
  * Add missing build dependency on dh addon.
  * Remove unused override

 -- Andreas Tille <tille@debian.org>  Mon, 17 Jan 2022 16:15:11 +0100

sambamba (0.8.1+dfsg-2) unstable; urgency=medium

  * Does not Build-Depend libbiod-dev any more
  * Fix watchfile to detect new versions on github

 -- Andreas Tille <tille@debian.org>  Thu, 09 Dec 2021 08:18:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,25 @@
 Source: sambamba
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-dlang,
-               libbiod-dev,
                libhts-dev (>= 1.10.2-4),
-               meson (>= 0.48),
+               meson,
                pkg-config,
                python3,
                shunit2 <!nocheck>,
                zlib1g-dev,
+               ldc,
 # used by libhts and explicitly referenced in build instruction
                liblz4-dev,
                libcurl4-gnutls-dev | libcurl-dev,
                libssl-dev,
                libbz2-dev,
                libdeflate-dev,
-               liblzma-dev
+               liblzma-dev,
+               debhelper
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/sambamba
 Vcs-Git: https://salsa.debian.org/med-team/sambamba.git

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, shunit2
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
  https://github.com/lomereiter/sambamba/releases .*/.*/v(\d[\d.pre-]+)@ARCHIVE_EXT@

## sambamba 1.0+dfsg

=== debian/changelog ===
sambamba (1.0+dfsg-1) unstable; urgency=medium

  * Fix watch file
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Thu, 19 Jan 2023 12:18:33 +0100

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
                libdeflate-dev,
                liblzma-dev,
                debhelper
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/sambamba
 Vcs-Git: https://salsa.debian.org/med-team/sambamba.git
 Homepage: https://github.com/lomereiter/sambamba

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,uversionmangle=s/-/~/,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/lomereiter/sambamba/tags .*/v(\d[\d.pre-]+)@ARCHIVE_EXT@

## sambamba 1.0.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -14,13 +14,19 @@
 #
 #   make LIBRARY_PATH=~/opt/ldc2-$ver-linux-x86_64/lib debug|profile|release|static
 #
+# With GNU Guix
+#
+#   env CC=gcc make VERBOSE=1 LIBRARY_PATH=/gnu/store/milyb96bnbnz7a107h7imswq1y5qhhk4-ldc-1.32.2/lib:$GUIX_ENVIRONMENT/lib static
+#
+# (note that we use gcc for linkind and it requires setting the lib path to find D's static libs)
+#
 # Static release with optimization (for releases):
 #
 #   env CC=gcc make static
 #
 # Debug version
 #
-#   make debug
+#   make debug VERBOSE=1
 #
 
 D_COMPILER=ldc2
@@ -33,14 +39,16 @@
   SYS = LINUX
 endif
 
-DFLAGS      = -wi -I. -IBioD -g -J.
+BIOD_PATH=./BioD:./BioD/contrib/msgpack-d/src
+DFLAGS      = -wi -I. -I$(BIOD_PATH) -g -J.
+LDFLAGS     = -L=-flto=full
 
 # DLIBS       = $(LIBRARY_PATH)/libphobos2-ldc.a $(LIBRARY_PATH)/libdruntime-ldc.a
-DLIBS_DEBUG = $(LIBRARY_PATH)/libphobos2-ldc-debug.a $(LIBRARY_PATH)/libdruntime-ldc-debug.a
-LIBS        = -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz -L-llz4
-# LIBS_STATIC = $(LIBRARY_PATH)/libc.a $(DLIBS) -L-llz4 -L-lz
-LIBS_STATIC = $(DLIBS) -L-lz -L-llz4 -L-lphobos2-ldc -L-ldruntime-ldc
-SRC         = utils/ldc_version_info_.d utils/lz4.d utils/strip_bcf_header.d $(sort $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d)) utils/version_.d $(sort $(wildcard thirdparty/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d))
+# DLIBS_DEBUG = $(LIBRARY_PATH)/libphobos2-ldc-debug.a $(LIBRARY_PATH)/libdruntime-ldc-debug.a
+# LIBS        = -L-L$(LIBRARY_PATH) -L-lpthread -L-lm -L-lz -L-llz4
+LIBS        = -L-lz -L-llz4
+LIBS_STATIC = -L-lz -L-llz4 -L-L$(LIBRARY_PATH) -L-lphobos2-ldc -L-ldruntime-ldc
+SRC         = $(wildcard main.d utils/*.d thirdparty/*.d) $(wildcard BioD/contrib/undead/*.d BioD/contrib/undead/*/*.d) $(wildcard BioD/bio/*/*.d BioD/bio/*/*/*.d BioD/bio/*/*/*/*.d BioD/bio/*/*/*/*/*.d BioD/bio/*/*/*/*/*/*/*.d BioD/contrib/msgpack-d/src/msgpack/*.d) $(wildcard sambamba/*.d sambamba/*/*.d sambamba/*/*/*.d)
 OBJ         = $(SRC:.d=.o)
 OUT         = bin/sambamba-$(shell cat VERSION)
 
@@ -54,12 +62,13 @@
 
 coverage:                          DFLAGS += -cov
 
-release static pgo-static:         DFLAGS += -O3 -release -enable-inlining -boundscheck=off -L-lz
+release static pgo-static:         DFLAGS += -O3 -release -enable-inlining -boundscheck=off
 
 static:                            DFLAGS += -static -L-Bstatic -link-defaultlib-shared=false $(LIBS_STATIC)
 
 pgo-static:                        DFLAGS += -fprofile-instr-use=profile.data
 
+# note use python3 for github CI:
 utils/ldc_version_info_.d:
 	python3 ./gen_ldc_version_info.py $(shell which ldmd2) > utils/ldc_version_info_.d
 	cat utils/ldc_version_info_.d
@@ -91,7 +100,7 @@
 # ---- Link step
 $(OUT): singleobj
 	$(info linking...)
-	$(D_COMPILER) $(DFLAGS) -of=$(OUT) $(OUT).o $(LINK_OBJ) $(LIBS)
+	$(D_COMPILER) $(DFLAGS) $(LDFLAGS) -of=$(OUT) $(OUT).o $(LINK_OBJ) $(LIBS)
 
 test: $(OUT)
 	$(OUT) --version

=== debian/changelog ===
sambamba (1.0.1+dfsg-1build3) noble; urgency=medium

  * Rebuild against new libphobos2-ldc-shared106.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Feb 2024 09:56:51 +0100

sambamba (1.0.1+dfsg-1build2) noble; urgency=medium

  * Rebuild against new libphobos2-ldc-shared105.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 08 Nov 2023 14:20:42 +0100

sambamba (1.0.1+dfsg-1build1) noble; urgency=medium

  * Rebuild against new libphobos2-ldc-shared105.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Nov 2023 09:23:36 +0100

sambamba (1.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 21 Aug 2023 15:21:43 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-dlang,
-               libhts-dev (>= 1.10.2-4),
+               libhts-dev,
                meson,
                pkg-config,
                python3,

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	dh $@ --buildsystem=meson
 
 override_dh_auto_configure:
-	dh_auto_configure -- -Doptimize_strong=true -Dcpp_link_args="-wi -L=-z -L=relro -L=/usr/lib/x86_64-linux-gnu/libbiod.a /usr/lib/x86_64-linux-gnu/libhts.a -L=-lz -L=-lcrypto -L=-lcurl -L=-llzma -L=-lbz2 -L=-ldeflate -L=-llz4"
+	dh_auto_configure -- -Doptimize_strong=true -Dcpp_link_args="-wi -L=-z -L=relro /usr/lib/x86_64-linux-gnu/libhts.a -L=-lz -L=-lcrypto -L=-lcurl -L=-llzma -L=-lbz2 -L=-ldeflate -L=-llz4"
 
 override_dh_missing:
 	dh_missing --fail-missing
